; My TI-92 module for TI-92 Expander2 Driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
my_ti:
        bsr ClearMenu           ; Wipe us clean
        bsr PutPaused            ; Pause
        WriteStr #10,#40,#4,runf ; "Run from:"
        WriteStr #10,#60,#4,memf ; Memory free
        bsr MemFree
        move.w d0,temp
        cmp.w #0,d1
        beq rf_shel
        WriteStr #100,#40,#4,home
        bra put_memf
rf_shel:
        WriteStr #100,#40,#4,shel
put_memf:
;        clr.l value
        move.w temp,value+2
        bsr PrintVal
        WriteStr #100,#60,#4,buffer
	WriteStr #10,#80,#4,version
        WriteStr #10,#90,#4,firmhlp
	bsr ver_get			; Get version
        clr.l value
	move.b inb,value+3
	bsr PrintVal
	WriteStr #120,#80,#4,buffer
        bra exit_dir
        
; Special thanks to Michael Donat for this freeware routine
MemFree:
        move.l  ($5d36),d0  ; pointer to top of heap
        sub.l   ($5d2e),d0  ; pointer to first free byte
        move.w  ($56b0),d1  ; handle # of current running ti-basic program
;        cmp.w   #0,d1           ; will be 0 if hot key used
;        bne     MemFree_ok
;        move.l  #100,d0         ; memory count bad (set to 0 after next instruction)
MemFree_ok:
        sub.l   #100,d0         ; diferance in what is reported and what is acually free
        rts

