; E2 Format Module for TI-92 Expander2 Driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
;
; Routines to "format" the Expander2 by writing $FF to all pages,
; erasing ALL data
format_eup:
        bsr ClearMenu
        WriteStr #10,#20,#4,warn1
        WriteStr #10,#30,#4,warn2
        WriteStr #10,#40,#4,warn3
        bsr wait_key                    ; Wait for a key
        cmp.w #70,d0
        beq format_now
        bra exit_now                    ; Aborted, exit
format_now:
        bsr ClearMenu
        WriteStr #10,#30,#4,form
        WriteStr #180,#30,#4,oftot
        bsr PutBusy
        move.w #0,page
format_loop:
        cmp.w #2048,page
        beq exit_format
        move.w #1,numba
        move.b #0,pstart
        lea buff2(PC),a0
        move.l a0,table_addr
        bsr get_sfe                     ; Get first byte of this page
        cmp.b #$FF,buff2                ; If its already erased...
        beq no_erase                    ; don't erase it
        bsr erase_sfe                   ; Call extlink.asm erase routine
no_erase:
        move.w page,value+2
        bsr PrintVal
        WriteStr #150,#30,#4,buffer     ; How many pages are done?
        move.w #15000,d7                ; Allow SFE time to re-program
        bsr delay_loop
        addq.w #1,page
        bra format_loop

exit_format:
        bsr PutPaused
        bra exit_dir
